
/*
	tag2tab - Convert a tag file to tag seperated

Note that this is ALPHA software, developed piecemeal while I
was testing various ideas.


Released under the GNU Copyright.

        Author: John Lines <john@paladin.demon.co.uk>





*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAXTAGLABELS 20
#define MAXLABELLEN 127
#include "tagtypes.h"

/* Global flags */
int HttpHeader=0;		/* If set then we output an http header */
int recbufsize=10000;        /* Size of a record buffer */
int doheader=1;
#define list 1
#define table 2
#define form 3
int htmlmode=list;
int numtaglabels=0;
int numtagheaders=0;
char taglabels[MAXTAGLABELS][MAXLABELLEN];
char tagheaders[MAXTAGLABELS][MAXLABELLEN];


void parseargs(int argc,char *argv[]);

void puttabrec(FILE *f, struct tagrecord *rec);

void main(int argc, char *argv[]) {

 struct tagrecord *record;
 char *fieldbuffer;

parseargs(argc,argv);


fieldbuffer=malloc(recbufsize);

if (doheader) {
    record=gettagrec(stdin,fieldbuffer);
    /* we dont do anything with the header - just throw it away */
    freetagrec(record);
    } 


while (!feof(stdin)) {
  record=gettagrec(stdin,fieldbuffer);
  puttabrec(stdout,record);
  freetagrec(record);
 }


}

void parseargs(int argc,char *argv[])
{

int arg=1;


/* Look for flags */

while ((arg<argc) && (argv[arg][0]=='-')) {
 switch (argv[arg][1]) {
case 'h':
  doheader=0; break;
case 'H':
  HttpHeader=1; break;
case 't':
  htmlmode=table;
  arg++;
  while ((arg<argc) && (argv[arg][0]!='-')) {
  strncpy(taglabels[numtaglabels],argv[arg],MAXLABELLEN); numtaglabels++;
  strncpy(tagheaders[numtagheaders],argv[arg],MAXLABELLEN); numtagheaders++;
  arg++;
  }
  break;
case 'T':
  arg++;
  while ((arg<argc) && (argv[arg][0]!='-')) {
  strncpy(tagheaders[numtagheaders],argv[arg],MAXLABELLEN); numtagheaders++;
  arg++;
  }
  break;
default:
   fprintf(stderr,"Tag2tab - unknown switch %c\n",argv[arg][1]);
}
arg++;
}


}


void puttabrec(FILE *f, struct tagrecord *rec)
/* put out a tag record as a set of TAB seperated fields */
{
 struct tagrecord *current;
 int i;
 int first=1;

current=rec;
if (current==0) return;
/*
*/

/* work our way through the taglabels looking for ones which match */
for (i=0; i<numtaglabels ; i++) {
if ( ! first ) fprintf(f,"\t");
first=0;
current=rec;   /* start at the beginning again */
while (current != 0) {
 if (strcmp(current->tagname,taglabels[i])==0) {
   /* if ( ! first ) fprintf(f,"\t");
   first=0; */
   fprintf(f,"%s",current->value);
   }
current=current->next;
}
}
fprintf(f,"\n");


}



